
function injectAdContainer() {
    var mainSection = document.querySelector('section');
    var mainImage = document.querySelector('figure');
    var paragraphs = mainSection.querySelectorAll('p');

    var separator = document.createElement('hr');
    separator.style.display = 'block';
    separator.style.clear = 'both';
    separator.style.visibility = 'hidden';

    var adContainer = document.createElement('div');
    adContainer.setAttribute('id', 'adContainer');

    // uncomment for debug
    //adContainer.style.backgroundColor = '#ff0099';
    //adContainer.style.height = '30px';

    var p;

    if (mainImage) {
        var iRect = mainImage.getBoundingClientRect();

        // find first p rendered after the mainImage
        var index = Array.from(paragraphs).findIndex(function(p, i) {
            var pRect = p.getBoundingClientRect();
            return pRect.top > iRect.bottom;
        });

        // if found, target previous p
        if (index !== -1) {
            p = index > 0 ? paragraphs[index-1] : paragraphs[index];
        }
    }

    if (!p) {
        p = paragraphs.length >= 2 ? paragraphs[1] : paragraphs[paragraphs.length - 1];
    }

    mainSection.insertBefore(adContainer, p.nextSibling);
    mainSection.insertBefore(separator, adContainer);
}

injectAdContainer();